/*******************************************************************************
 * FoxCustomizationNode_MiniMartList generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxCustomizationNode_MiniMartList extends FoxCustomizationNode_ContainerBase within FoxArmoryUI
    abstract
    config(UI);

var const config array<config BaseUnlockFilterEntry> UnlockFilters;
var const config array<config FoxTypes.EUnlockState> FilteredUnlockStates;
var private transient string PagePath;
var private transient FoxUIMiniMartListWidget ListWidget;

function Initialize(optional bool bSelectEquipped)
{
    local array<string> ScrollerCategories;
    local int I;

    bSelectEquipped = true;
    super.Initialize(bSelectEquipped);
    I = 0;
    J0x24:
    // End:0xC0 [Loop If]
    if(I < UnlockFilters.Length)
    {
        ScrollerCategories.AddItem(Outer.Outer.LocalizeMenuString(UnlockFilters[I].EntryLabel, "UnlockFilters"));
        ++ I;
        // [Loop Continue]
        goto J0x24;
    }
    PagePath = as_addArmoryMartListWidget(0, 23, "");
    Outer.Outer.Outer.Advance(0.0);
    ListWidget = FoxUIMiniMartListWidget(Outer.Outer.Outer.GetVariableObject(PagePath, class'FoxUIMiniMartListWidget'));
    // End:0x2FA
    if(ListWidget != none)
    {
        ListWidget.Initialize(Outer.Outer.Outer.PCOwner);
        ListWidget.PurchaseLocation = 1;
        ListWidget.bDeducePackTypes = true;
        ListWidget.SetString("extFunction", "ei_selectMartListEntry");
        ListWidget.ApplyUnlockStateFilter(FilteredUnlockStates);
        as_addCategoryBar(ScrollerCategories,, "ei_selectCategoryScrollerEntry");
        ei_selectCategoryScrollerEntry();
    }
    Outer.Outer.Outer.as_transition("menuInSkills");
    //return;    
}

function Cleanup()
{
    super.Cleanup();
    // End:0x43
    if(ListWidget != none)
    {
        ListWidget.Cleanup();
        ListWidget = none;
    }
    //return;    
}

function RebuildScroller(optional bool bSelectEquipped)
{
    bSelectEquipped = false;
    //return;    
}

protected function SetListLabel(string Label)
{
    // End:0x95
    if(ListWidget != none)
    {
        ListWidget.SetString("listLabel", Outer.Outer.LocalizeMenuString(Label, Outer.ArmoryLocalizationSectionName));
    }
    //return;    
}

protected function ei_selectCategoryScrollerEntry(optional int Index)
{
    // End:0xF8
    if(((ListWidget != none) && Index >= 0) && Index < UnlockFilters.Length)
    {
        // End:0xB0
        if(UnlockFilters[Index].UnlockTypes.Length > 0)
        {
            ListWidget.ApplyUnlockTypeFilter(UnlockFilters[Index].UnlockTypes);
        }
        // End:0xD8
        else
        {
            ListWidget.ApplyUnlockTypeFilter(RootUnlockFilter);
        }
        ListWidget.Refresh();
    }
    //return;    
}

protected function ei_selectMartListEntry(int Index)
{
    // End:0x58
    if(ListWidget != none)
    {
        ListWidget.PurchaseItem(ListWidget.GetItemGuidFromIndex(Index), false);
    }
    //return;    
}

private final function string as_addArmoryMartListWidget(int PosX, int PosY, optional string ExtInterfaceClickFunc)
{
    return Outer.Outer.Outer.ActionScriptString("_root.addArmoryInventoryList");
    //return ReturnValue;    
}

private final function as_addCategoryBar(const array<string> Categories, optional int StartIndex, optional string ExtInterfaceClickFunc)
{
    ListWidget.ActionScriptString("setScroller");
    //return;    
}

defaultproperties
{
    UnlockFilters(0)=(EntryLabel="All",UnlockTypes=none)
    FilteredUnlockStates(0)=252
    FilteredUnlockStates(1)=41
    FilteredUnlockStates(2)=0
    WidgetContainerName="martContainer"
}